#ifndef ALWAYS_CERTAIN_COMPILE_CORRECTLY_GUARANTEEING_HEADER
#define ALWAYS_CERTAIN_COMPILE_CORRECTLY_GUARANTEEING_HEADER

#if !__arm__
# error "To compile this code, you must pass the following options to clang/gcc: -target armv7a-eabi -mbig-endian -mfloat-abi=hard -mhard-float -mfpu=vfpv4 -mhwdiv=thumb,arm -D__ELF__"
#else
# if !_ILP32
#  error "Ints, longs, and pointers should be 32-bit. Undo whatever you did to change that."
# endif
# if !__ARMEB__ || !__ARM_BIG_ENDIAN || !__BIG_ENDIAN__
#  error "-mbig-endian not passed"
# endif
# if !__ARM_EABI__ || __ARM_ARCH != 7 || !__ARM_ARCH_7A__ || __ARM_ARCH_PROFILE != 'A'
#  error "-target armv7a-eabi not passed"
# endif
# if !__ARM_VFPV3__ || !__ARM_VFPV4__ || !__VFP_FP__
#  error "-mfpu=vfpv4 not passed"
# endif
# if !__THUMB_INTERWORK__
#  error "Thumb interworking has been disabled, re-enable it"
# endif
# if !__ARM_ARCH_EXT_IDIV__
#  error "-mhwdiv=thumb,arm not passed"
# endif
#endif

#endif
