#ifndef INTERCHANGEH
#define INTERCHANGEH

#include <lua.h>
#include <inttypes.h>

#define INVOKE_SUCCESS 0
#define INVOKE_UNKNOWN_ERROR 1
#define INVOKE_LIMIT_REACHED 2
#define INVOKE_UNKNOWN_RECEIVER 3
#define INVOKE_INDIRECT_REQUIRED 4
#define INVOKE_UNKNOWN_METHOD 5

#define ICTAG_STRING(x) (x)
#define ICTAG_BYTE_ARRAY(x) ((x)+16384)
#define ICTAG_UUID (-8)
#define ICTAG_COMPOUND (-7)
#define ICTAG_ARRAY (-6)
#define ICTAG_INT (-5)
#define ICTAG_DOUBLE (-4)
#define ICTAG_BOOLEAN (-3)
#define ICTAG_NULL (-2)
#define ICTAG_END (-1)

typedef int16_t interchange_tag;

extern int16_t ic_get_type(const void* p);
extern const void* ic_push(lua_State* L, const void* p);
extern const void* ic_skip(const void* p);

extern void* get_io_buffer(size_t size);

#endif
