#ifndef FAKE_MATHH
#define FAKE_MATHH

#include <correctly_compiled.h>

/* Just enough of math.h to make Lua compile. */

#define INFINITY (__builtin_inff())
#define NAN (__builtin_nanf(""))

double ldexp(double x, int exp) __attribute__((pure));
double pow(double x, double y) __attribute__((pure));
double floor(double x) __attribute__((pure));
double ceil(double x) __attribute__((pure));
double fabs(double x) __attribute__((pure));
double sin(double x) __attribute__((pure));
double sinh(double x) __attribute__((pure));
double cos(double x) __attribute__((pure));
double cosh(double x) __attribute__((pure));
double tan(double x) __attribute__((pure));
double tanh(double x) __attribute__((pure));
double asin(double x) __attribute__((pure));
double acos(double x) __attribute__((pure));
double atan(double x) __attribute__((pure));
double atan2(double y, double x) __attribute__((pure));
double fmod(double x, double y) __attribute__((pure));
double modf(double x, double* iptr) __attribute__((pure));
double sqrt(double x) __attribute__((pure));
double log(double x) __attribute__((pure));
double log10(double x) __attribute__((pure));
double exp(double x) __attribute__((pure));
double frexp(double x, int* exp) __attribute__((pure));

#define HUGE_VAL __builtin_huge_val()

#endif
