#ifndef FAKE_STDIOH
#define FAKE_STDIOH

#include <correctly_compiled.h>
#include <stddef.h>

/* Just enough of stdio.h to make Lua compile. */
#define BUFSIZ 2048
#define _IONBF 0
#define _IOLBF 1
#define _IOFBF 2
#define EOF (-1)
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
#define L_tmpnam 0

typedef struct _FILE FILE;

int sprintf(char* buf, const char* format, ...) __attribute__((format(printf,2,3)));
int fprintf(FILE* f, const char* format, ...) __attribute__((format(printf,2,3)));
int fscanf(FILE* f, const char* format, ...) __attribute__((format(scanf,2,3)));

FILE* fopen(const char* path, const char* mode);
FILE* freopen(const char* path, const char* mode, FILE* f);
FILE* tmpfile(void);
int fclose(FILE* f);
int feof(FILE* f);
int ferror(FILE* f);
int fflush(FILE* f);
size_t fread(void* buf, size_t size, size_t nmemb, FILE* f);
size_t fwrite(const void* buf, size_t size, size_t nmemb, FILE* f);
int getc(FILE* f);
char* fgets(char* s, int size, FILE* f);
int fputs(const char* s, FILE* f);
int ungetc(int c, FILE* f);
void clearerr(FILE* f);
int fseek(FILE* f, long offset, int whence);
long ftell(FILE* f);
int setvbuf(FILE* f, char* buf, int mode, size_t size);
int remove(const char* pathname);
int rename(const char* oldpath, const char* newpath);
char* tmpnam(char* s);

// extern FILE* stdin, *stdout, *stderr;
// don't take up precious BSS space for these
#define stdin NULL
#define stdout NULL
#define stderr NULL

#endif
