#ifndef FAKE_STDLIBH
#define FAKE_STDLIBH

#include <correctly_compiled.h>

/* Just enough of stdlib.h to make Lua compile. */

#include <stddef.h>

#define NULL ((void*)0)

#define EXIT_SUCCESS 0
#define EXIT_FAILURE 1

static inline int abs(int j) { return j<0?-j:j; }

static inline int system(const char* command) {
  if(command == NULL) return 0; /* no shell */
  else return -1; /* "error?" */
}

static inline char* getenv(const char* name) {
  return NULL;
}

void exit(int status) __attribute__((noreturn));
void abort(void) __attribute__((noreturn));

void* malloc(size_t size) __attribute__((malloc,warn_unused_result));
void free(void* ptr);
void* calloc(size_t nmemb, size_t size) __attribute__((malloc,warn_unused_result));
void* realloc(void* ptr, size_t size) __attribute__((warn_unused_result));

double strtod(const char* nptr, char** endptr);

#define RAND_MAX (2147483647)
int rand(void);
void srand(unsigned int seed);

#endif
