#include "ctype.h"

/* only handle ASCII */

int isalnum(int c) {
  return isalpha(c) || isdigit(c);
}

int isalpha(int c) {
  return islower(c) || isupper(c);
}

int isascii(int c) {
  return c < 0x80;
}

int isblank(int c) {
  return c == ' ' || c == '\t';
}

int iscntrl(int c) {
  return c < ' ';
}

int isdigit(int c) {
  return c >= '0' && c <= '9';
}

int isgraph(int c) {
  return c > ' ' && c < 0x7f;
}

int islower(int c) {
  return c >= 'a' && c <= 'z';
}

int isprint(int c) {
  return c >= ' ' && c < 0x7f;
}

int ispunct(int c) {
  return isgraph(c) && !isalpha(c);
}

int isspace(int c) {
  return c == ' ' || c == '\f' || c == '\n' || c == '\r' || c == '\t' || c == '\v';
}

int isupper(int c) {
  return c >= 'A' && c <= 'Z';
}

int isxdigit(int c) {
  return isdigit(c) || (c >= 'a' && c <= 'f') || (c >= 'A' && c <= 'F');
}

int toascii(int c) {
  return c & 0x7f;
}

int toupper(int c) {
  if(islower(c)) return c - 0x20;
  else return c;
}

int tolower(int c) {
  if(isupper(c)) return c + 0x20;
  else return c;
}
