#include "uuid.h"
#include <string.h>
#include <stdio.h>
#include <ctype.h>

const char* uuid2staticstring(const struct uuid* uuid) {
  static char buffer[37];
  uuid2string(uuid, buffer);
  return buffer;
}

void uuid2string(const struct uuid* uuid, char buffer[37]) {
  // TODO: snprintf
  sprintf(buffer, "%08X-%04X-%04X-%04X-%02X%02X%02X%02X%02X%02X",
           uuid->first, uuid->second, uuid->third, uuid->fourth,
           uuid->rest[0], uuid->rest[1], uuid->rest[2],
           uuid->rest[3], uuid->rest[4], uuid->rest[5]);
}

static uint8_t digit2value(char digit) {
  /* assumes it's a hex digit */
  if(digit >= 'a') return (digit - 'a' + 10);
  else if(digit >= 'A') return (digit - 'A' + 10);
  else return digit - '0';
}

static bool outbytes(uint8_t* outp, const char* inp, int count) {
  while(count-- > 0) {
    if(!isxdigit(inp[0]) || !isxdigit(inp[1])) return false;
    *outp++ = (digit2value(inp[0]) << 4) | digit2value(inp[1]);
    ++inp;
  }
  return true;
}

bool string2uuid(struct uuid* uuid, const char* buffer) {
  if(strlen(buffer) != 36) return false;
  if(buffer[8] != '-' || buffer[13] != '-' || buffer[18] != '-'
     || buffer[23] != '-') return false;
  uint8_t* p = (uint8_t*)uuid;
  if(!outbytes(p, buffer + 0, 4)) return false; p += 4;
  if(!outbytes(p, buffer + 9, 2)) return false; p += 2;
  if(!outbytes(p, buffer + 14, 2)) return false; p += 2;
  if(!outbytes(p, buffer + 19, 2)) return false; p += 2;
  if(!outbytes(p, buffer + 24, 6)) return false;
  return true;
}
