package name.bizna.jarmtest;
import java.io.RandomAccessFile;

import name.bizna.jarm.*;

public class JARMTest {
	static CPU cpu;
	static PhysicalMemorySpace mem;
	public static void main(String[] args) {
		if(args.length != 1) {
			System.err.println("Usage: JARMTest rom.rom");
			System.exit(1);
		}
		try {
			cpu = new CPU();
			mem = cpu.getMemorySpace();
			/* ROM */
			RandomAccessFile f = new RandomAccessFile(args[0], "r");
			if(f.length() > 1024 * 1024) { f.close(); throw new RuntimeException("ROM file too large"); }
			byte[] b = new byte[(int)f.length()];
			f.readFully(b);
			f.close();
			mem.mapRegion(0x00000000, new ByteArrayRegion(b, false));
			/* RAM */
			mem.mapRegion(0x10000000, new ByteArrayRegion(1024 * 1024));
			/* IO */
			cpu.mapCoprocessor(7, new FakeIOCoprocessor(cpu));
			/* GO!*/
			cpu.reset(false, true, false);
			cpu.setExceptionDebugMode(false);
			cpu.setDebugDumpMode(true);
			while(!cpu.execute(10000))
				;
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		cpu.dumpState(System.err);
		cpu.dumpExtraState(System.err);
	}
}
